package api

import (
	"model/msp"
	"mspkey/fc"
	"mspkey/info"
	"net/http"

	"github.com/gin-gonic/gin"
)

//获取网络验证信息
func GetMspkeyinfo(c *gin.Context) {

	var p info.MspKey
	sql := new(msp.DB)
	sql.Init(info.Mysqlurl)
	defer sql.DB.Close()
	num := 0
	sql.DB.Model(&info.MspKey{}).First(&p).Count(&num)
	if num > 0 {

		c.JSON(http.StatusOK, gin.H{
			"code": "1",
			"msg":  "成功",
			"data": p,
		})
		return

	}
}

//用户名是否存在 外部接口
func IsName(c *gin.Context) {
	type st struct {
		Name string `form:"Name" json:"Name" binding:"required"`
		Mode string `form:"Mode" json:"Mode" binding:"required"`
	}

	var p st
	err := c.BindJSON(&p)

	if err != nil || len(p.Name) < 5 {
		c.String(400, "参数错误")
		return
	}

	if fc.IsName(p.Name, p.Mode) {
		c.JSON(http.StatusOK, gin.H{
			"code": "1",
			"msg":  "用户存在",
		})
		return
	} else {
		c.JSON(http.StatusOK, gin.H{
			"code": "0",
			"msg":  "用户不存在",
		})
		return
	}

}

//判断卡密是否存在
func IsCar(c *gin.Context) {
	type st struct {
		Serial string
	}

	var p st
	err := c.BindJSON(&p)
	if err != nil {
		return
	}

	if p.Serial == "" {
		c.String(400, "参数错误")

		return
	}

	var car info.Car
	if fc.IsCar(p.Serial, &car) {

		c.JSON(http.StatusOK, gin.H{
			"code": "1",
			"msg":  "成功",
			"data": car,
		})
		return

	} else {

		c.JSON(http.StatusOK, gin.H{
			"code": "0",
			"msg":  "卡密不存在",
		})
		return
	}

}

//卡密充值
func Recharge(c *gin.Context) {
	type st struct {
		Serial string `form:"Serial" json:"Serial" binding:"required"`
		Name   string `form:"Name" json:"Name" binding:"required"`
	}

	var p st
	err := c.BindJSON(&p)
	if err != nil {
		c.String(400, "参数错误")
		return
	}

	if fc.Recharge(p.Serial, p.Name) {
		c.JSON(http.StatusOK, gin.H{
			"code": "1",
			"msg":  "成功",
		})

	} else {
		c.JSON(http.StatusOK, gin.H{
			"code": "0",
			"msg":  "失败",
		})

	}

}
