package fc

import (
	"fmt"
	"mspkey/info"
	"time"

	"github.com/gin-gonic/gin"

	uuid "github.com/satori/go.uuid"

	"model/msp"
)

//注册用户 注册成功为真
func ReMake(name, pwd, qq string) bool {

	sql := new(msp.DB)
	sql.Init(info.Mysqlurl)
	defer sql.DB.Close()

	//注册为作者
	var p info.Make
	p.Name = name
	p.Pwd = pwd
	p.QQ = qq
	p.Money = 0
	p.Retime = time.Now()
	p.Vip = "0"
	err := sql.DB.Create(&p).Error
	if err != nil {
		return false
	}
	return true

}

//登录
func MakeLogin(name, pwd string, c *gin.Context) (token string) {

	sql := new(msp.DB)
	sql.Init(info.Mysqlurl)
	defer sql.DB.Close()

	//作者登录
	num := 0
	sql.DB.Model(&info.Make{}).Where("`Name` = ? and `Pwd` = ?", name, pwd).Count(&num)
	if num > 0 {
		//写入登录时间 和ip
		sql.DB.Model(&info.Make{}).Where("`Name` = ? and `Pwd` = ?", name, pwd).Update(&info.Make{
			Loginip:   c.ClientIP(),
			Logintime: time.Now(),
		})
		//找到用户 返回token
		var t time.Duration
		t = time.Minute * 20
		to := new(msp.Token)
		return to.GetToken(name, info.Key, t)
	}
	return ""

}

//判断是否是作者
func IsMake(name string) bool {

	sql := new(msp.DB)
	sql.Init(info.Mysqlurl)
	defer sql.DB.Close()
	num := 0
	sql.DB.Model(&info.Make{}).Where("`Name` = ?", name).Count(&num)
	if num > 0 {
		return true
	}
	return false
}

//添加软件  mode 1 添加 2 更新
func Addsof(sof *info.Sof, mode string) bool {

	sql := new(msp.DB)
	sql.Init(info.Mysqlurl)
	defer sql.DB.Close()

	switch mode {
	case "1":

		sof.Regtime = time.Now()
		sof.Money = 0
		err := sql.DB.Create(&sof).Error
		if err != nil {
			return false
		}
		return true

	case "2":

		err := sql.DB.Model(&info.Sof{}).Where("`Sname` = ? and `Skey` = ?", sof.Sname, sof.Skey).Update(&info.Sof{
			Version: sof.Version,
			Notice:  sof.Notice,
			Data:    sof.Data,
			State:   sof.State,
			Address: sof.Address,
			Md5:     sof.Md5,
		}).Error

		if err != nil {
			return false
		}
		return true
	default:
		return false
	}

}

//删除软件  根据id 秘钥 作者删除
func Delsof(name, skey, id string) bool {

	sql := new(msp.DB)
	sql.Init(info.Mysqlurl)
	defer sql.DB.Close()

	err := sql.DB.Where("`id` = ? and `Skey` = ? and `Make`= ?", id, skey, name).Delete(&info.Sof{}).Error
	if err != nil {
		return false
	}

	num := 0

	err = sql.DB.Model(&info.Sof{}).Where("`Skey` = ?", skey).Count(&num).Error

	if num == 0 {
		//没有找到 说明删除了
		//就删除 相关卡密 和 用户
		sql.DB.Where("`Skey` = ?", skey).Delete(&info.Car{})
		sql.DB.Where("`Skey` = ?", skey).Delete(&info.User{})

		return true
	} else {
		return false
	}

}

//获取软件列表
func Getsoflist(name string, list *[]info.Sof) bool {

	sql := new(msp.DB)
	sql.Init(info.Mysqlurl)
	defer sql.DB.Close()

	err := sql.DB.Where("`Make` = ? ", name).Find(&list).Error
	if err != nil {
		return false
	}

	return true
}

//添加卡密
func Addcars(name string, num int, data *info.Car) bool {

	sql := new(msp.DB)
	sql.Init(info.Mysqlurl)
	defer sql.DB.Close()

	data.State = "0"
	data.Crtime = time.Now()
	data.Name = name

	for i := 0; i < num; i++ {
		//随机生成列号
		u1, _ := uuid.NewV4()
		data.Id = 0
		data.Serial = u1.String()
		err := sql.DB.Create(&data).Error
		if err != nil {
			return false
		}
	}
	return true

}

//查询卡密列表
func Getcarlist(name, Skip, mode, Skey string, list *[]info.Car) bool {
	sql := new(msp.DB)
	sql.Init(info.Mysqlurl)
	sql.Init(info.Mysqlurl)
	defer sql.DB.Close()

	switch mode {
	case "0":
		//所有卡
		err := sql.DB.Where("`Name` = ? and `Skey` = ?", name, Skey).Offset(Skip).Limit(24).Find(&list).Error
		if err != nil {
			return false
		}
		return true

	case "1":
		//未使用的卡
		err := sql.DB.Where("`Name` = ? and `Skey` = ? and `State`= ?", name, Skey, "0").Offset(Skip).Limit(24).Find(&list).Error
		if err != nil {
			return false
		}
		return true
	case "2":
		//已使用的卡
		err := sql.DB.Where("`Name` = ? and `Skey` = ? and `State`= ?", name, Skey, "1").Offset(Skip).Limit(24).Find(&list).Error
		if err != nil {
			return false
		}
		return true
	default:
		return false
	}

}

//获取用户列表 name=作者
func Getuserlist(name string, Skey string, mode string, Skip string, list *[]info.User) bool {

	sql := new(msp.DB)
	sql.Init(info.Mysqlurl)
	defer sql.DB.Close()
	switch mode {
	case "0":
		//查询所有用户
		fmt.Println("666666666666")
		err := sql.DB.Where("`Mame` = ? and `Skey` = ?", name, Skey).Offset(Skip).Limit(24).Find(&list).Error

		if err != nil {
			return false
		}
		return true
	case "1":
		//查询在线用户
		err := sql.DB.Where("`Mame` = ? and `Skey` = ? and `State` = ?", name, Skey, "1").Offset(Skip).Limit(24).Find(&list).Error
		if err != nil {
			return false
		}
		return true
	case "2":
		//离线用户
		err := sql.DB.Where("`Mame` = ? and `Skey` = ? and `State` = ?", name, Skey, "0").Offset(Skip).Limit(24).Find(&list).Error
		if err != nil {
			return false
		}
		return true
	case "3":
		//过期用户
		err := sql.DB.Where("`Mame` = ? and `Skey` = ? and `Endtime` < ?", name, Skey, time.Now()).Offset(Skip).Limit(24).Find(&list).Error
		if err != nil {
			return false
		}
		return true
	case "-1":
		err := sql.DB.Where("`Mame` = ? and `Skey` = ? and `State` = ?", name, Skey, "-1").Offset(Skip).Limit(24).Find(&list).Error
		if err != nil {
			return false
		}
		return true
	default:
		return false
	}

}

//获取当用户
func GetUser(MakeName, UserName string, lis *info.User) bool {

	sql := new(msp.DB)
	sql.Init(info.Mysqlurl)
	defer sql.DB.Close()
	num := 0
	sql.DB.Model(&info.User{}).Where("`Mame` = ? and `Name` = ?", MakeName, UserName).First(&lis).Count(&num)
	if num > 0 {
		return true
	}
	return false

}

//修改用户状态/下线/禁用
func SetUserSt(MakeName, UserName, newSt string) bool {

	sql := new(msp.DB)
	sql.Init(info.Mysqlurl)
	defer sql.DB.Close()
	var p info.User
	num := 0
	sql.DB.Model(&info.User{}).Where("`Mame` = ? and `Name` = ?", MakeName, UserName).First(&p).Count(&num)
	if num == 0 {
		return false
	}

	err := sql.DB.Model(&info.User{}).Where("`Mame` = ? and `Name` = ?", MakeName, UserName).Update(&info.User{
		State: newSt,
	}).Error

	if err != nil {

		return false
	}

	return true
}

//修改作者密码
func SetMakePwd(MakeName, OPwd, NPwd string) bool {
	sql := new(msp.DB)
	sql.Init(info.Mysqlurl)
	defer sql.DB.Close()
	var p info.Make
	num := 0
	sql.DB.Model(&info.Make{}).Where("`Name` = ? and `Pwd` = ?", MakeName, OPwd).First(&p).Count(&num)
	if num == 0 {
		return false
	}
	err := sql.DB.Model(&info.Make{}).Where("`Name` = ? and `Pwd` = ?", MakeName, OPwd).Update(&info.Make{
		Pwd: NPwd,
	}).Error
	if err != nil {
		return false
	}
	return true

}

//获取个人信息
func GetMakeInfo(MakeName string, p *info.Make) bool {

	sql := new(msp.DB)
	sql.Init(info.Mysqlurl)
	defer sql.DB.Close()
	num := 0
	sql.DB.Model(&info.Make{}).Where("`Name` = ?", MakeName).First(&p).Count(&num)
	if num > 0 {
		return true
	} else {
		return false
	}

}
