package info

import "time"

const Key = "mspkey"

const Mysqlurl = "mspkey:110110@/mspkey?charset=utf8&parseTime=True&loc=Local"

//作者表
type Make struct {
	Id        int
	Name      string    `gorm:"unique;not null"` //唯一的账号 使用邮箱账号
	Pwd       string    `gorm:"not null"`        //密码不为空
	QQ        string    `gorm:"not null"`        //联系方式
	Vip       string    //等级 等级越高 打折越厉害  0表示不是vip 1-9
	Money     float64   //余额
	Loginip   string    //登录ip
	Logintime time.Time //登录时间
	Retime    time.Time //注册时间

}

//客户表
type User struct {
	Id        int
	Name      string    `gorm:"unique;not null"` //唯一的账号 使用邮箱账号
	Pwd       string    `gorm:"not null"`        //密码不为空
	QQ        string    `gorm:"not null"`        //联系方式
	Intl      int       //积分
	Retime    time.Time //注册时间
	State     string    //状态  0离线 1在线 -1被禁用
	Htnum     int       //心跳数
	Endtime   time.Time //到期时间
	Loginip   string    //登录ip
	Logintime time.Time //登录时间
	Facid     string    //设备id
	Sname     string    //软件名称
	Skey      string    //软件秘钥
	Mame      string    //软件作者
	Bak       string    //备注
}

//软件表
type Sof struct {
	Id      int       //标识
	Sname   string    `gorm:"not null"`        //软件名称
	Skey    string    `gorm:"unique;not null"` //软件秘钥
	Version string    //软件版本
	Notice  string    //软件公告
	Data    string    //软件数据
	State   string    //软件状态  1. 开启  0. 关闭
	Regtime time.Time //软件注册时间
	Make    string    //软件的作者
	Money   float64   //销售额
	Address string    //软件跟新地址
	Usernum int       //用户数量
	Md5     string    //软件md5值
}

//卡密表
type Car struct {
	Id      int       //标识 自己的
	Sname   string    `gorm:"not null"`        //对应的软件的名称
	Skey    string    `gorm:"not null"`        //对应软件的key
	Serial  string    `gorm:"unique;not null"` //卡密序列号
	Tp      int       `gorm:"not null"`        //卡密类型  0.小时卡 1.天卡 2.周卡 3.月卡
	Money   float64   //售价
	State   string    //状态   1.已使用  0.未使用
	Crtime  time.Time //制卡时间
	Name    string    //制卡人
	Use     string    //使用者
	Usetime time.Time //使用时间
}

type MspKey struct {
	Title  string //标题
	Notice string //公告
	QQF    string //QQ群链接地址
	Qun    string //qq加群图片地址
	Weixin string //微信赞助图片地址
	ZFB    string //支付宝图片赞助地址
}
