package main

import (
	"model/msp"
	"mspkey/api"
	"mspkey/fc"

	"github.com/gin-contrib/cors"
	"github.com/gin-gonic/gin"
)

func main() {

	go msp.CheckOut()
	fc.CreatTable()

	r := gin.Default()
	// same as
	// config := cors.DefaultConfig()
	// config.AllowAllOrigins = true
	// r.Use(cors.New(config))
	r.Use(cors.Default())
	r.Static("img", "./img")
	//获取网络验证信息
	r.GET("api/Mspkey", api.GetMspkeyinfo)

	//用户名是否存在
	r.POST("api/pub/IsUname", api.IsName)
	//获取卡密单张
	r.POST("api/pub/IsCar", api.IsCar)
	//注册作者
	r.POST("api/make/ReMake", api.ReMake)
	//作者登录
	r.POST("api/make/MakeLogin", api.MakeLogin)
	//添加软件
	r.POST("api/make/Addsof", api.Addsof)
	//删除软件
	r.POST("api/make/Delsof", api.Delsof)
	//获取软件列表
	r.POST("api/make/Getsoflist", api.Getsoflist)
	//生成卡密
	r.POST("api/make/Addcars", api.Addcars)
	//获取卡密列表
	r.POST("api/make/Getcarlist", api.Getcarlist)
	//获取用户表
	r.POST("api/make/Getuserlist", api.Getuserlist)

	//充值卡密
	r.POST("api/pub/Recharge", api.Recharge)
	//获取单用户
	r.POST("api/make/GetUser", api.GetUser)
	//修改用户状态
	r.POST("api/make/SetUserSt", api.SetUserSt)
	//修改作者密码
	r.POST("api/make/SetMakePwd", api.SetMakePwd)
	//获取作者个人信息
	r.POST("api/make/GetMakeInfo", api.GetMakeInfo)
	//---------------------------------------
	//用户接口
	//注册用户
	r.POST("api/user/ReUser", api.ReUser)
	//用户登录
	r.POST("api/user/UserLogin", api.UserLogin)
	//用户下线
	r.POST("api/user/UserDown", api.UserDown)
	//发送心跳包
	r.POST("api/user/SendH", api.SendH)
	//获取个人信息
	r.POST("api/user/GetUserInfo", api.GetUserInfo)
	//修改用户密码
	r.POST("api/user/SetUserPwd", api.SetUserPwd)
	//获取软件信息
	r.POST("api/user/GetSofInfo", api.GetSofInfo)

	r.Run()

}
